#!/usr/bin/php5
<?php

/**
Do a graph Pie with nrcpt values. 
Only 10 cases graphed :
    ncrpt = 1       nrcpt ]5,10[ 
    nrcpt = 2       nrcpt [10,20[
    nrcpt = 3       nrcpt [20,30[
    nrcpt = 4       nrcpt [30,50[
    nrcpt = 5       nrcpt [50,[

**/


/* Fichier de conf (log/mdp) MySQL */
require("/usr/share/bm-stats/www/conf/config.php");
require("/usr/share/bm-stats/www/function/date.php");
require("/usr/share/bm-stats/www/function/lang.php");


/* Variables modifiables*/
$path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;
$dataFile = "/var/lib/bm-stats/general/domainNbRecipByPost.dat";

/* DO NOT TOUCH AFTER */
if(date("z") == "0" ) { $this_year = date("Y") - 1 ; }
else { $this_year = date("Y"); }


$mktime_yesterday = mktime(0,0,0,date("m"),date("d")-1,date("y"));
$this_year  = date("Y",$mktime_yesterday);
$this_week  = date("W",$mktime_yesterday);
$this_month = date("m",$mktime_yesterday);
$this_n_day   = date("z",$mktime_yesterday);    
    
/* Liste des titres dans les graphes */
//$list_title['nbRecipRepart']['title']     = $do_graph_nbRecipRepart_title ;
// Recup. des donnees depuis le fichier
$values = read_domainNbRecipByPostFile();

//print_r($values['mclabosse.fr']) ;


// Creation des images
foreach (array_keys($values) as $domain) {

    $myLang = getLang($domain) ;
    if(!empty($myLang)) $lang=$myLang ;
    require("/usr/share/bm-stats/www/inc_lang/inc_lang_$lang.php");

    $this_lit_month = get_month($this_month); 
    $this_full_day = date("d",$mktime_yesterday)." ".$this_lit_month." ".$this_year;
    
    $case_img = array(    
                    "nrcpt" => array(    
                                    "titley" => "$do_graph_nrcpt_titley $this_year",
                                    "titlem" => "$do_graph_nrcpt_titlem $this_lit_month $this_year",
                                    "titlew" => "$do_graph_nrcpt_titlew $this_week ($this_year)",
                                    "titled" => "$do_graph_nrcpt_titled $this_full_day "
                                    ));


    
        
    foreach(array_keys($case_img) as $case) {
        
        graph_nbRcpt_repartition($values,$domain,$case,"y") ;
        graph_nbRcpt_repartition($values,$domain,$case,"m") ;
        graph_nbRcpt_repartition($values,$domain,$case,"w") ;
        graph_nbRcpt_repartition($values,$domain,$case,"d") ;
    };
};



/* DO NOT TOUCH AFTER */



/* Debut des fonctions locales */


function verif_existence_rep($rep) {
    $PATH=$rep;
    if(!(is_dir($PATH))) {
        $cmd = "mkdir -p $PATH ; chmod -R 755 $PATH  ; chown -R root.www-data $PATH";
        exec($cmd);
    } else {
        $cmd = "chmod -R 755 $PATH ; chown -R root.www-data $PATH ";
        exec($cmd);
    };
};



function read_domainNbRecipByPostFile() {
    Global $this_year,$this_week,$this_month,$this_n_day,$dataFile  ;
    $thisArray = array() ;

    $case = array("y","m","w","d");
    $key  = array("1","2","3","4","5","<10","<20","<30","<50",">=50") ;


    $data = file($dataFile);
    sort($data); 
    
    foreach($data as $line) {
        if(preg_match("/GlobalServer|Externe/",$line)) {
        
        } else {
    
            if(preg_match("/^$this_year/",$line)) {
        
                $val = explode(",",$line) ;
                $thisDate   = $val[0]; 
                   $elementDate = explode("-",$thisDate);
                    $element_year   = $elementDate[0];         
                    $element_month  = $elementDate[1];
                    $element_day    = $elementDate[2];                     
                    $element_mktime = mktime(0,0,0,$element_month,$element_day,$element_year) ;
                     $element_n_day  = date("z",$element_mktime);
                     $element_week   = date("W",$element_mktime);
                     $element_num_day_of_week = date("N",$element_mktime) ;

                $thisDomain = $val[1];
                

                foreach ($case as $Case) {
                    foreach ($key as $Key) { 
                        $thisArray[$thisDomain][$Case][$Key] += 0 ;
                    };
                };



                $values = explode(";",$val[2]);
                foreach ($values as $elements) {

                    $nbRcpt = 0 ;
                    $nbRcptValue = 0 ;
                    $counter  =  explode(":",$elements) ;
                    $nbRcpt      = $counter[0];
                    $nbRcptValue = $counter[1];

                    if ($nbRcpt == 1) {
                        
                        $thisArray[$thisDomain]['y']['1'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['1'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['1'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['1'] += $nbRcptValue;    
                                
                    }; 
                    
                    if ($nbRcpt == 2) {

                        $thisArray[$thisDomain]['y']['2'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['2'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['2'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['2'] += $nbRcptValue;

                    }; 
                    
                    if ($nbRcpt == 3) {

                        $thisArray[$thisDomain]['y']['3'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['3'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['3'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['3'] += $nbRcptValue;

                    }; 
                    
                    if ($nbRcpt == 4) {

                        $thisArray[$thisDomain]['y']['4'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['4'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['4'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['4'] += $nbRcptValue;

                    }; 
                    
                    if ($nbRcpt == 5) {
                        
                        $thisArray[$thisDomain]['y']['5'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['5'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['5'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['5'] += $nbRcptValue;

                    }; 
                    
                    if ($nbRcpt>5 and $nbRcpt<10) {
                        
                        $thisArray[$thisDomain]['y']['<10'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['<10'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['<10'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['<10'] += $nbRcptValue;

                    }; 
                    
                    if ($nbRcpt>=10 and $nbRcpt<20) {

                        $thisArray[$thisDomain]['y']['<20'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['<20'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['<20'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['<20'] += $nbRcptValue;

                    };
                    
                    if ($nbRcpt>=20 and $nbRcpt<30) {   

                        $thisArray[$thisDomain]['y']['<30'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['<30'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['<30'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['<30'] += $nbRcptValue;

                    };
                    
                    if ($nbRcpt>=30 and $nbRcpt<50) {

                        $thisArray[$thisDomain]['y']['<50'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['<50'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['<50'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['<50'] += $nbRcptValue;

                    };
                    
                    if($nbRcpt >= 50) { 
                                                 
                        $thisArray[$thisDomain]['y']['>=50'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_month==$element_month) ) $thisArray[$thisDomain]['m']['>=50'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_week==$element_week) ) $thisArray[$thisDomain]['w']['>=50'] += $nbRcptValue;
                        if( ($this_year==$element_year) and  ($this_n_day==$element_n_day) ) $thisArray[$thisDomain]['d']['>=50'] += $nbRcptValue;
                        
                    };    
               
                }; 
            };
        };
    };

    return $thisArray ;
};



/*
Draw an image with values returned by get_userAgent_repartition()
void graph_nbRcpt_repartition(&$thisValues,$domain,$case,$type)
*/
function graph_nbRcpt_repartition(&$thisValues,$domain,$case,$type) {

    Global $this_year,$this_week,$this_month,$this_n_day  ;
    Global $path_to_data,$path_to_pChart,$case_img;        
            
    $path_to_img = $path_to_data.$domain."/img/".$this_year."/";

    // Ctrl existance du dossier image
    verif_existence_rep($path_to_img);

    if($type=="y") {
        $title    = $case_img[$case]['titley'] ;
        $img = $path_to_img."Y".$this_year."_".$case.".png" ;
    };

    if($type=="m") {
        $title    = $case_img[$case]['titlem'] ;
        $img = $path_to_img."M".$this_month."_".$case.".png" ;
    };

    if($type=="w") {
        $title    = $case_img[$case]['titlew'] ;
        $img = $path_to_img."W".$this_week."_".$case.".png" ;
    };

    if($type=="d") {
        $title    = $case_img[$case]['titled'] ;
        $img = $path_to_img."D".$this_n_day."_".$case.".png" ;
    };

 
    foreach ($thisValues[$domain][$type] as $key=>$values) {
        $x[] = $values ;
        $y[] = "$key Dest/Post ($values)" ;

    };



    /* pChart library inclusions */
    $path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;
    require_once $path_to_pChart."class/pData.class.php";
    require_once $path_to_pChart."class/pDraw.class.php";
    require_once $path_to_pChart."class/pImage.class.php";
    require_once $path_to_pChart."class/pRadar.class.php";


    /* Create and populate the pData object */
    $MyData = new pData();
    $MyData->addPoints($x,"Posts");
    $MyData->setSerieDescription("Posts","Répartition par nrcpt");

    /* Define the absissa serie */
    $MyData->addPoints($y,"Labels");
    $MyData->setAbscissa("Labels");


    $MyData->setPalette("Score",array("R"=>157,"G"=>196,"B"=>22));

     
    /* Create the pChart object */
    $myPicture = new pImage(700,420,$MyData);
    
    $myPicture->drawGradientArea(0,0,700,420,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));
    $myPicture->drawGradientArea(0,0,700,20,DIRECTION_HORIZONTAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>10,"EndG"=>85,"EndB"=>133,"Alpha"=>100));

    
    $myPicture->drawLine(0,20,700,20,array("R"=>255,"G"=>255,"B"=>255));
    $RectangleSettings = array("R"=>180,"G"=>180,"B"=>180,"Alpha"=>100);
             
    /* Add a border to the picture */
    $myPicture->drawRectangle(0,0,699,419,array("R"=>0,"G"=>0,"B"=>0));
                               
    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(10,15,$title,array("R"=>255,"G"=>255,"B"=>255));
                                                 
    /* Set the default font properties */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>10,"R"=>0,"G"=>0,"B"=>0));
                                                         
    /* Enable shadow computing */
    $myPicture->setShadow(TRUE,array("X"=>2,"Y"=>2,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>10));
                                                                 
    /* Create the pRadar object */
    $SplitChart = new pRadar();
                                                                         
    /* Draw a radar chart */
    $myPicture->setGraphArea(10,35,690,410);
    $Options = array("DrawTicks"=> TRUE, "TicksLength" => 6, "DrawPoly"=>TRUE,"WriteValues"=>TRUE,"ValueFontSize"=>8,"Layout"=>RADAR_LAYOUT_STAR, "LabelPos"=>RADAR_LABELS_HORIZONTAL,"BackgroundGradient"=>array("StartR"=>255,"StartG"=>255,"StartB"=>255,"StartAlpha"=>100,"EndR"=>207,"EndG"=>227,"EndB"=>125,"EndAlpha"=>50));
    $SplitChart->drawRadar($myPicture,$MyData,$Options);

    /* Write the Service*/
    $myPicture->drawFromPNG(530,364,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");

    /* Render the picture (choose the best way) */
    $myPicture->render($img);

};


?>
